unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Grids;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    tanxBtn: TButton;
    Series2: TLineSeries;
    Series3: TPointSeries;
    StringGrid1: TStringGrid;
    NEdit: TLabeledEdit;
    NsetBtn: TButton;
    interpolationBtn: TButton;
    procedure tanxBtnClick(Sender: TObject);
    procedure NsetBtnClick(Sender: TObject);
    procedure interpolationBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure GridSet(Sin, Colin: integer);
    procedure FGridSet(Sin, Colin: integer);    // ObhTCYύX
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

type
  DArray = array of double;

// ObhTCY̕ύX
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W:integer;                                // ȏ̓XN[
begin
  if (StringGrid1.ColCount = Colin) and (StringGrid1.RowCount = Sin) then exit;
  StringGrid1.ColWidths[0] := 30;
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      W := (StringGrid1.DefaultColWidth + 1) * (Colin - 1) + 31;
//      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssVertical;       // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
end;

// ObhŒs̐ݒ
procedure TForm1.FGridSet(Sin, Colin: integer);
var
  E : integer;
begin
  GridSet(Sin, Colin);
  for E := 1 to Sin - 1 do
      StringGrid1.Rows[E].Text := intTostr(E);
  StringGrid1.Cols[1].Text := 'x';
  StringGrid1.Cols[2].Text := 'y';
end;

// We[uݒ
procedure maketable(x, y : DArray; N: integer);    // Wy[]ɏ㏑
var
  i, j : integer;
begin
  for j := 0 to N - 2 do begin
    if x[j] = x[j + 1] then begin
      application.MessageBox(pchar('x' + inttostr(j+1) + ' x' + inttostr(j+2)
                                         + 'lłB'),'',0);
      exit;
    end;
  end;
  for j := 0 to N - 1 do
    for i := j + 1 to N - 1 do begin
      if y[i] - y[j] = 0 then begin
        application.MessageBox(pchar('y' + inttostr(i+1) + '-y' + inttostr(j+1)
                                         + '[ɂȂ܂B'),'',0);
        exit;
      end;
      y[i] := (x[i] - x[j]) / (y[i] - y[j]);
    end;
end;

// ԌvZ
function interpolate(x, y: DArray; N: integer; t: double): double;  // 
var
  i : integer;
  r : double;
begin
  r := y[N - 1];
  for i := N - 2 downto 0 do
    r := (t - x[i]) / r + y[i];
  result := r;
end;

// Qlltax(x)Zbg
procedure TForm1.tanxBtnClick(Sender: TObject);
var
  N : integer;
  i, imax : integer;
  s, t, e, es : double;
  x, y : Darray;
begin
  N := 5;
  Nedit.Text := inttostr(N);
  GridSet(N + 1, 3);
  setlength(x, N);
  setlength(y, N);
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  for i := 0 to N - 1 do begin
    x[i] := 20 * i;
    y[i] := tan(x[i] * pi / 180);
    Series3.AddXY(x[i], y[i]);
    StringGrid1.cells[1,i + 1] := floatTostr(x[i]);
    StringGrid1.cells[2,i + 1] := floatTostr(y[i]);
  end;
  maketable(x, y, N);                   // \̍쐬
  imax := (N - 1) * 20;
  es := 1e3;
  chart1.RightAxis.Title.Text := '덷~1E3';

  for i := 0 to imax do begin
    t := tan(i * pi / 180);
    s := interpolate(x, y, N, i);       // ԌvZ
    Series1.AddXY(i, s);
    e := (s - t) * es;
    Series2.AddXY(i, e);
  end;
end;

// ObhNZbg
procedure TForm1.NsetBtnClick(Sender: TObject);
var
  N, ch : integer;
begin
  val(Nedit.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if N > 100 then begin
    application.MessageBox('N100ɂĉB','',0);
    exit;
  end;
  GridSet(N + 1, 3);
end;

// Obh̒lɂԌvZ
procedure TForm1.interpolationBtnClick(Sender: TObject);
var
  N, ch, i, imax : integer;
  x, y : Darray;
  cn : string;
  s, dx, xx : double;
begin
  val(Nedit.Text, N, ch);
  if ch <> 0 then begin
    application.MessageBox('N̓͂ɊԈႢL܂B','',0);
    exit;
  end;
  if N > 100 then begin
    application.MessageBox('N100ɂĉB','',0);
    exit;
  end;
  GridSet(N + 1, 3);
  setlength(x, N);
  setlength(y, N);
  for i := 0 to N - 1 do begin
    val(StringGrid1.cells[1,i + 1], x[i], ch);
    if ch <> 0 then begin
      cn := 'x' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
    val(StringGrid1.cells[2,i + 1], y[i], ch);
    if ch <> 0 then begin
      cn := 'y' + intTostr(i + 1) + 'ɊԈႢL܂B';
      application.MessageBox(pchar(cn),'',0);
      break;
    end;
  end;
  if ch <> 0 then exit;
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  for i := 0 to N - 1 do
    Series3.AddXY(x[i], y[i]);
  maketable(x, y, N);                     // \̍쐬
  imax := (N - 1) * 20;
  chart1.RightAxis.Title.Text := '';
  dx := (x[N-1] - x[0]) / imax;
  for i := 0 to imax do begin
    xx := i * dx + x[0];
    s := interpolate(x, y, N, xx);        // ԌvZ
    Series1.AddXY(xx, s);
  end;
end;

// Obhݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  FGridSet(101, 3);                 // Œs11 + 100s2܂ōsύXĂ
                                    // ͒lNAȂ悤ɂ܂B
  GridSet(4, 3);                    // ŏ̐ݒ
end;

end.
