unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Button1: TButton;
    Series2: TLineSeries;
    Series3: TPointSeries;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses system.Math;

type
  DArray = array of double;

// W\vZ
procedure maketable(x, y : DArray; N: integer);    // Wy[]ɏ㏑
var
  i, j : integer;
begin
  for j := 0 to N - 1 do
    for i := j + 1 to N - 1 do begin
      if y[i] - y[j] = 0 then begin
        application.MessageBox(pchar('y' + inttostr(i+1) + '-y' + inttostr(j+1)
                                         + '[ɂȂ܂B'),'',0);
        exit;
      end;
      y[i] := (x[i] - x[j]) / (y[i] - y[j]);
    end;
end;

// AɂԌvZ
function interpolate(x, y: DArray; N: integer; t: double): double;  // 
var
  i : integer;
  r : double;
begin
  r := y[N - 1];
  for i := N - 2 downto 0 do
    r := (t - x[i]) / r + y[i];
  result := r;
end;

// ԌvZOt}
procedure TForm1.Button1Click(Sender: TObject);
const
  PITCH = 20;
var
  N : integer;
  i, imax : integer;
  s, t, e, es : double;
  x, y : Darray;                     // array of double
begin
  N := 5;                            // 0`80
  t := 0;
  es := 1;
  case RadioGroup1.ItemIndex of
    0: N := 19;                      // 0`360
    1: N := 10;                      // 0`180
//    2: N := 5;                       // 0`80
  end;
  setlength(x, N);
  setlength(y, N);
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  for i := 0 to N - 1 do begin
    x[i] := PITCH * i;
    case RadioGroup1.ItemIndex of
      0: y[i] := sin(x[i] * pi / 180);
      1: y[i] := cos(x[i] * pi / 180);
      2: y[i] := tan(x[i] * pi / 180);
    end;
    Series3.AddXY(x[i], y[i]);
  end;
  maketable(x, y, N);                   // \̍쐬
  case RadioGroup1.ItemIndex of
    0:  begin
          es := 1e6;
          chart1.RightAxis.Title.Text := '덷~1E6';
        end;
    1:  begin
          es := 1e6;
          chart1.RightAxis.Title.Text := '덷~1E6';
        end;
    2:  begin
          es := 1e3;
          chart1.RightAxis.Title.Text := '덷~1E3';
        end;
  end;
  imax := (N - 1) * PITCH;
  for i := 0 to imax do begin           // Ot}
    case RadioGroup1.ItemIndex of
      0: t := sin(i * pi / 180);
      1: t := cos(i * pi / 180);
      2: t := tan(i * pi / 180);
    end;
    s := interpolate(x, y, N, i);       // ԌvZ
    Series1.AddXY(i, s);
    e := (s - t) * es;                  // 덷
    Series2.AddXY(i, e);
  end;
end;

end.
